Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.hp.hpl.jena.reasoner.rulesys
Interface ForwardRuleInfGraphI

All Superinterfaces:
  Graph, GraphAdd, InfGraph, SilentAddI

All Known Implementing Classes:
  BasicForwardRuleInfGraph, FBRuleInfGraph, RDFSRuleInfGraph, RETERuleInfGraph

    public interface ForwardRuleInfGraphI

extends InfGraph, SilentAddI

This interface collects together the operations on the InfGraph which are needed to support the forward rule engine.

Version:
  $Revision: 1.14 $ on $Date: 2008/01/02 12:07:47 $
Author:
  Dave Reynolds

Field Summary

Fields inherited from interface com.hp.hpl.jena.graph.Graph
`emptyGraph`

Method Summary
`void` | `addBRule(Rule brule)` Adds a new Backward rule as a rules of a forward rule process.
`void` | `addDeduction(Triple t)` Add a new deduction to the deductions graph.
`void` | `deleteBRule(Rule brule)` Deletes a new Backward rule as a rules of a forward rule process.
`ExtendedIterator` | `findDataMatches(Node subject, Node predicate, Node object)` Search the combination of data and deductions graphs for the given triple pattern.
`Graph` | `getCurrentDeductionsGraph()` Return the Graph containing all the static deductions available so far.
`Graph` | `getDeductionsGraph()` Return the Graph containing all the static deductions available so far.
`void` | `logDerivation(Triple t, java.lang.Object derivation)` Log a dervivation record against the given triple.
`boolean` | `shouldLogDerivations()` Return true if derivation logging is enabled.
`boolean` | `shouldTrace()` Return true if tracing should be acted on - i.e. if traceOn is true and we are past the bootstrap phase.

Methods inherited from interface com.hp.hpl.jena.reasoner.InfGraph
`find, getDerivation, getGlobalProperty, getRawGraph, getReasoner, prepare, rebind, rebind, reset, setDerivationLogging, testGlobalProperty, validate`

Methods inherited from interface com.hp.hpl.jena.graph.Graph
`close, contains, contains, delete, dependsOn, find, find, getBulkUpdateHandler, getCapabilities, getEventManager, getPrefixMapping, getReifier, getStatisticsHandler, getTransactionHandler, isClosed, isEmpty, isIsomorphicWith, queryHandler, size`

Methods inherited from interface com.hp.hpl.jena.graph.GraphAdd
`add`

Methods inherited from interface com.hp.hpl.jena.reasoner.rulesys.SilentAddI
`silentAdd`

Method Detail

### shouldTrace

    boolean shouldTrace()

  Return true if tracing should be acted on - i.e. if traceOn is true and we are past the bootstrap phase.

### addBRule

    void addBRule(Rule brule)

  Adds a new Backward rule as a rules of a forward rule process. Only some infgraphs support this.

### deleteBRule

    void deleteBRule(Rule brule)

  Deletes a new Backward rule as a rules of a forward rule process. Only some infgraphs support this.

### getDeductionsGraph

    Graph getDeductionsGraph()

  Return the Graph containing all the static deductions available so far. Triggers a prepare if the graph has not been prepared already.

  Specified by:
    `getDeductionsGraph` in interface `InfGraph`
  Returns:
    the deductions graph, if relevant for this class of inference engine or null if not.

### getCurrentDeductionsGraph

    Graph getCurrentDeductionsGraph()

  Return the Graph containing all the static deductions available so far. Does not trigger a prepare action.

### addDeduction

    void addDeduction(Triple t)

  Add a new deduction to the deductions graph.

### findDataMatches

    ExtendedIterator findDataMatches(Node subject,
                                     Node predicate,
                                     Node object)

  Search the combination of data and deductions graphs for the given triple pattern. This may different from the normal find operation in the base of hybrid reasoners where we are side-stepping the backward deduction step.

### shouldLogDerivations

    boolean shouldLogDerivations()

  Return true if derivation logging is enabled.

### logDerivation

    void logDerivation(Triple t,
                       java.lang.Object derivation)

  Log a dervivation record against the given triple.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Hewlett-Packard Development Company, LP